#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define __EXC_INTERNAL
#include <exc.h>
#include <watch.h>

#if defined(__BORLANDC__) || defined(__MSC__) || defined(__WATCOMC__)
#define HAVE_INLINE_ASM
#endif

void Usage (void)
{
  puts ("Usage: DEMO_1 <exc number>\n"
        "\t 0  divide error\n"
        "\t 3  break point\n"
        "\t 4  integer overflow\n"
#ifdef HAVE_INLINE_ASM
        "\t 5  array bound\n"
#endif
        "\t 6  illegal opcode\n"
        "\t10  invalid Task Segment\n"
        "\t11  segment not present\n"
        "\t12  stack fault\n"
        "\t13  general protection\n"
        "\t14  page fault\n\n");
#if !defined(__DJGPP__)
  puts ("       DEMO_1 {EX | RD | WR | } to test watch-points\n");
#endif
  exit (0);
}

UINT Get_TSS (void)
{
  return (0);
}

void Set_OFlag (void)
{
  EMIT(0x9C);                                       /* pushfd */
  EMIT(0x58);                                       /* pop eax */
  EMIT(0x0D); EMIT(0); EMIT(8); EMIT(0); EMIT(0);   /* or eax,800h */
  EMIT(0x50);                                       /* pusp eax */
  EMIT(0x9d);                                       /* popfd */
}

void foo (void)
{
}

void crash (int ex)
{
  UINT   page;
  FARPTR fp;
  char   buf [1];
  UINT   limit[2] = {1,10};
  UINT   a, b = 10, c;

  switch (ex)
  {
    case 0:
         a = 0; c = b/a;
         break;

    case 3:
         EMIT (0xCC);            /* int 3 */
         break;

    case 4:
         Set_OFlag();
         EMIT (0xCE);            /* into */
         break;

#ifdef HAVE_INLINE_ASM
    case 5:
         _asm mov esi, 11
         _asm bound esi, limit
         break;
#endif

    case 6:
         EMIT (0xF0); EMIT(0xE4); EMIT(0x40);  /* lock: in al,40h */
         break;

    case 10:
         a = Get_TSS();
         EMIT (0x0F); EMIT(0); EMIT(0xD8);     /* LTR AX */
         break;

    case 12:
         *((char*) (buf+0x1000000)) = 1;
         break;

    case 13:
         *((char*) -1) = 1;
         break;

#if defined(__DJGPP__)
    case 11:
         _farpeekb (0x84, 0);
         break;

    case 14:
         *(char*)0 = 1;
         break;
#else
    case 11:
         FP_SET (fp, NULL, 0x84);
         PeekFarByte (fp);
         break;

    case 14:
         _dx_add_umapg (SS_DATA, 1, &page);
         *(char*)page = 1;
         break;
#endif

    default:
         printf ("No action for exception %d defined\n", ex);
         Usage();
  }
}

int main (int argc, char **argv)
{
  int    rc    = 0;
  static int watch = 0;

  if ((argc != 2) || (strcmp(argv[1],"-?") == 0))
     Usage();

  excCoreFile = 0;
#if defined(__WATCOMC__) && 0
  excAsmLines = 0;
#endif
  InstallExcHandler (NO_EXC_HOOK);  /* no application exception hook */

#if !defined(__DJGPP__)
  if (!stricmp(argv[1],"EX"))
  {
    rc = SetDebugWatch ((ULONG)&foo, 1, DR7_BINST);
    foo();
    watch = 1;
  }
  else if (!stricmp(argv[1],"WR"))
  {
    rc = SetDebugWatch ((ULONG)&watch, 1, DR7_BWR);
    watch = 1;
  }
  else if (!stricmp(argv[1],"RD"))
  {
    rc = SetDebugWatch ((ULONG)&watch, 1, DR7_BRW);
    watch = 1;
  }

  if (watch)
  {
    printf ("SetDebugWatch() = %d\n", rc);
    return (0);
  }
#endif

  crash (atoi(argv[1]));
  return (0);
}

