#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <exc.h>

#define IRET_OPCODE  0xCF

SWI_REGS regs;
char     called = 0;

/*-----------------------------------------------------*/

void MouseCallback (SWI_REGS *reg)
{
  regs   = *reg; /* copy regs from mouse API */
  called = 1;    /* cprintf() isn't reentrant. Simply set flag */
}

void MouseUserHandler (USHORT mask, REALPTR handler)
{
  SWI_REGS reg;
  reg.ecx = mask;
  reg.eax = 0x0C;
  reg.es  = RP_SEG (handler);
  reg.edx = RP_OFF (handler);
  _dx_real_int (0x33,&reg);
}

void Abort (char *str)
{
  puts (str);
  exit (1);
}

int main (void)
{
  REALPTR iv,rmcb;

  InstallExcHandler (NULL);

  _dx_rmiv_get (0x33,&iv);
  if (!iv || PeekRealByte(iv) == IRET_OPCODE)
     Abort ("No mouse driver");

  rmcb = _dx_alloc_rmode_wrapper_retf (MouseCallback,NULL,0,256);
  if (!rmcb)
     Abort ("Cannot allocate real-mode callback");

  /*install mouse-hook for left-button press/release event */
  MouseUserHandler (2+4,rmcb);

  while (!kbhit())
  {
    if (called)
       cprintf ("eax %04lX, ebx %04lX, ecx %04lX, edx %04lX, edi %04lX, "\
                "esi %04lX, ds %04X, es %04X\r\n",
                regs.eax, regs.ebx, regs.ecx, regs.edx,
                regs.edi, regs.esi, regs.ds,  regs.es);
    called = 0;
  }

  MouseUserHandler (0,0L);
  _dx_free_rmode_wrapper (rmcb);

  return (0);
}

