
#if !defined(__DJGPP__)
#error This file is for djgpp only
#endif

#include <stdio.h>
#include <malloc.h>
#include <string.h>

#define __EXC_INTERNAL
#include "../../exc.h"
#include "../trace.h"


static SYMENT *f_symtab;
static char   *f_string_table;

static inline char *valid_symbol (int i)
{
  char *sn;
  int   len;

  if (f_symtab[i].e.e.e_zeroes)
       sn = f_symtab[i].e.e_name;
  else sn = f_string_table + f_symtab[i].e.e.e_offset;

  len = strlen (sn);
  if ((unsigned char) sn[len-1] >= 0x80)
  {
    sn[len-1] = '\0';
    len--;
  }
  if ((sn[0] != '_') || (len < 2) ||
      ((unsigned char) sn[len-1] >= 0x80) ||
      !strncmp(sn, "___gnu_compiled", 15) ||
      !strcmp(sn, "__DYNAMIC"))
     return (NULL);
  return (sn+1);
}

ULONG GetCoffSymbols (int fd, long ofs)
{
  FILHDR f_fh;
  ULONG  strsize;
  int    i, nsyms;

  lseek (fd, ofs, SEEK_SET);
  read (fd, &f_fh, sizeof(f_fh));

  lseek (fd, ofs + f_fh.f_symptr + f_fh.f_nsyms * SYMESZ, SEEK_SET);
  read (fd, &strsize, sizeof(strsize));

  f_string_table = calloc (strsize,1);
  read (fd, f_string_table+4, strsize-4);

  lseek (fd, ofs + f_fh.f_symptr, SEEK_SET);
  f_symtab = malloc (f_fh.f_nsyms * SYMESZ);
  read (fd, f_symtab, SYMESZ * f_fh.f_nsyms);

  for (i = nsyms = 0; i < f_fh.f_nsyms; i++)
  {
    if (f_symtab[i].e_sclass == C_EXT ||
        f_symtab[i].e_sclass == C_STAT)
    {
      char *name = valid_symbol (i);
      if (name)
      {
        if (!AddAddrSymbol(name, f_symtab[i].e_value, 0))
           break;
        nsyms++;
      }
    }
    i += f_symtab[i].e_numaux;
  }

  free (f_string_table);
  free (f_symtab);
  return (nsyms);
}
