#
# Makefile (Borland make) for HighC/Pharlap exception handler library
#

OBJDIR = .\obj\highc

.AUTODEPEND
.PATH.OBJ = $(OBJDIR)

CC  = hc386 -c -g -w2 -O2 -Hnocopyr -I..
ASM = tasm /mx /t /i.\pharlap
LIB = ..\lib\exc_hc.lib

OBJECTS = $(OBJDIR)\exc_0.obj    $(OBJDIR)\reg.obj    \
          $(OBJDIR)\sig_0.obj    $(OBJDIR)\clock.obj  \
          $(OBJDIR)\ftol.obj     $(OBJDIR)\farmem.obj \
          $(OBJDIR)\seh_0.obj    $(OBJDIR)\glue.obj   \
          $(OBJDIR)\exc_1.obj    $(OBJDIR)\uasm.obj   \
          $(OBJDIR)\printk.obj   $(OBJDIR)\trace.obj  \
          $(OBJDIR)\demangle.obj $(OBJDIR)\cview.obj  \
          $(OBJDIR)\seh_1.obj    $(OBJDIR)\rmcb.obj   \
          $(OBJDIR)\sig_1.obj    $(OBJDIR)\intr.obj   \
          $(OBJDIR)\watch.obj    $(OBJDIR)\pharlap.obj

all: $(LIB)

     
$(LIB): $(OBJECTS)
    386lib $< @&&|
      -nowarn -replace $(OBJECTS)
|

.asm.obj:
    $(ASM) $*.asm, $@

.c.obj:
    $(CC) $*.c -o $@

clean:
    del $(OBJDIR)\*.obj

$(OBJDIR)\exc_0.obj:    pharlap\exc_0.asm
$(OBJDIR)\sig_0.obj:    pharlap\sig_0.asm
$(OBJDIR)\clock.obj:    pharlap\clock.asm
$(OBJDIR)\ftol.obj:     pharlap\ftol.asm
$(OBJDIR)\farmem.obj:   pharlap\farmem.asm
$(OBJDIR)\seh_0.obj:    pharlap\seh_0.asm
$(OBJDIR)\glue.obj:     pharlap\glue.asm
$(OBJDIR)\reg.obj:      pharlap\reg.asm

$(OBJDIR)\exc_1.obj:    exc_1.c
$(OBJDIR)\uasm.obj:     uasm.c
$(OBJDIR)\printk.obj:   printk.c
$(OBJDIR)\trace.obj:    trace.c
$(OBJDIR)\demangle.obj: demangle.c
$(OBJDIR)\cview.obj:    pharlap\cview.c
$(OBJDIR)\seh_1.obj:    pharlap\seh_1.c
$(OBJDIR)\rmcb.obj:     pharlap\rmcb.c
$(OBJDIR)\sig_1.obj:    pharlap\sig_1.c
$(OBJDIR)\intr.obj:     pharlap\intr.c
$(OBJDIR)\watch.obj:    pharlap\watch.c
$(OBJDIR)\pharlap.obj:  pharlap\pharlap.c
