#ifndef __TARGET_H
#define __TARGET_H

#if !defined(__HIGHC__) && !defined(__FLAT__) && !defined(__WATCOMC__) && !defined(_MSC_VER)
#error This file is for Pharlap targets only
#endif

#include <pharlap.h>

/* For 32-bit compilers with far-pointers
 */
#if (__CMPLR_FEATURES__ & __FEATURE_FARPTR__) && defined(USE_FP)
  extern char _far *dosFp;

  #define peekb(s,o)    *(UCHAR  _far*)(dosFp+(ULONG)((o)|(s)<<4))
  #define peekw(s,o)    *(USHORT _far*)(dosFp+(ULONG)((o)|(s)<<4))
  #define peekl(s,o)    *(ULONG  _far*)(dosFp+(ULONG)((o)|(s)<<4))
  #define pokeb(s,o,x)  *(UCHAR  _far*)(dosFp+(ULONG)((o)|(s)<<4))=(UCHAR)(x)
  #define pokew(s,o,x)  *(USHORT _far*)(dosFp+(ULONG)((o)|(s)<<4))=(USHORT)(x)
  #define pokel(s,o,x)  *(ULONG  _far*)(dosFp+(ULONG)((o)|(s)<<4))=(ULONG)(x)
#else
  #define peekb(s,o)    PeekRealByte ((s<<16)+(o))
  #define peekw(s,o)    PeekRealWord ((s<<16)+(o))
  #define peekl(s,o)    PeekRealDWord((s<<16)+(o))
  #define pokeb(s,o,x)  PokeRealByte ((s<<16)+(o),(x))
  #define pokew(s,o,x)  PokeRealWord ((s<<16)+(o),(x))
  #define pokel(s,o,x)  PokeRealDWord((s<<16)+(o),(x))
#endif

#endif
