
TITLE Structured Exception Handling (level 0)
NAME  SEH_0

INCLUDE exc.inc

_DATA SEGMENT
    PUB_DD excBlk, 0         ; internal exc-block info address
    PUB_DD except_TOS, 0     ; ESP in __try block

     _try_exc_jb_  label dword
    @_try_exc_jb   ExcStruc <0>    ; jmp_buf for try block

      oldHookMain  dd 0            ; old exc-hook address
      except_EBP   dd 0            ; EBP for try() block

PUBLIC @_try_exc_jb, _try_exc_jb_
PUBLIC @__InitExceptBlock
EXTRN  @_excHookMain : dword       ; exception hook main address

_DATA ENDS

;=========================================================================

_TEXT SEGMENT

EXTRN _InstallExcHandler : near            ; in exc_1.c
EXTRN _except_try_hook   : near            ; in seh_1.c

;
; Called by compiler (BCC32) before a try/except block is entered.
; EAX = address of compiler generated try_excBlk structure
;
@__InitExceptBlock:
       mov  _excBlk, eax            ; EAX -> struct excBlk
       push eax                     ; save the address
       push 0
       call _InstallExcHandler      ; InstallExcHandler((excHook)0L);
       pop  ecx

       mov  eax, @_excHookMain
       mov  oldHookMain, eax        ; remember old hook address
       lea  eax, _except_try_hook
       mov  @_excHookMain, eax      ; set new hook address
       pop  eax                     ; EAX -> struct excBlk
       mov  [eax].exceptFlag, 0     ; clear exc-occured flag
       mov  ecx, ebp
       add  ecx, [eax].exceptTOS
       mov  _except_TOS, ecx        ; save TOS for later long-jumps
       mov  except_EBP, ebp         ; remember EBP
       ret

;
; void _Return_unwind (void *try_top_of_stack)
;
C_PROC _Return_unwind
       mov ecx, oldHookMain
       mov @_excHookMain, ecx       ; restore old hook address
       ret

;
; void _set_filt_args (int exc_code, struct _EXCEPTION_POINTERS *exc_info);
;
C_PROC _set_filt_args
       mov eax,[esp+4]              ; EAX = exc_code
       mov ecx,[esp+8]              ; ECX = exc_info
       mov edx,except_EBP           ; EDX = EBP at SEH location
       mov ss:[edx-12],eax          ; store exc_code
       mov ss:[edx-8], ecx          ; and exc_info pointer
       ret

;
; void _exc_setjmp (jmp_buf *buf);
;
C_PROC _exc_setjmp
       mov  eax, [esp+4]
       mov  [eax]._ESI, esi
       mov  [eax]._EDI, edi
       mov  [eax]._EBP, ebp
       mov  [eax]._EBX, ebx
       mov  [eax]._ECX, ecx
       mov  [eax]._EDX, edx
       mov  [eax]._ESP, esp
       push dword ptr [esp]
       pop  [eax]._EIP
       mov  [eax]._EAX, eax
       ret

;
; void _exc_longjmp (jmp_buf *buf, int retval)
;
C_PROC _exc_longjmp
       mov  ecx, [esp+4]
       mov  eax, [esp+8]
       mov  esi, [ecx]._ESI
       mov  edi, [ecx]._EDI
       mov  ebx, [ecx]._EBX
       mov  edx, [ecx]._EDX
       mov  esp, [ecx]._ESP
       mov  ebp, [ecx]._EBP
       push [ecx]._EIP              ; return to [ecx]._EIP
       mov  ecx, [ecx]._ECX
       ret                          ; return code eax = retval

_TEXT ENDS

END
