#ifndef __EXC_WATCH_H
#define __EXC_WATCH_H

/*
 * Error codes from watch-point handlers
 */
#define WP_ERR_NONE       (0)
#define WP_ERR_OVERLAP    (-1)
#define WP_ERR_ILL_ADDR   (-2)
#define WP_ERR_ILL_LENGTH (-3)
#define WP_ERR_ILL_TYPE   (-4)
#define WP_ERR_NO_MEM     (-5)
#define WP_ERR_NOT_FOUND  (-6)


extern int   SetDebugWatch   (ULONG addr, int len, ULONG type);
extern int   ClearDebugWatch (ULONG addr);
extern char *GetDebugWatch   (ULONG addr);

#ifdef __HIGHC__
  /*
   * Avoid namespace pollution by prefixing publics with "@_"
   */
  #define RENAME_SYM(x) pragma Alias(x,"@_" #x "")

  RENAME_SYM (SetDebugWatch);
  RENAME_SYM (ClearDebugWatch);
  RENAME_SYM (GetDebugWatch);

#endif /* __HIGHC__ */

#endif /* __EXC_WATCH_H */
